[b]Tags And Mentions[/b]

Like many other platforms, Red uses a special notation inside messages to indicate &quot;tags&quot; or contextual links to other entities.

[b]Mentions[/b]

Channels are tagged by simply preceding their name with the @ character. 

[code]
@Jack
[/code]

When you start to mention somebody, it will create an auto-complete box to select from your immediate connections. Select one as appropriate.

If the person mentioned is in the list of recipients for the post, they will receive a tag notification.   


[b]Deliverable Mentions[/b]

Some connections in the mention auto-complete box behave differently than others. If you mention a channel which provides "re-delivery of mentions" it will also send the post to all of that channel's default delivery connections. This is how one posts to "forums". The auto-complete box will provide two entries for these channels, one will mention just the channel. The other will invoke re-delivery and be listed as the channel's "network". 

[code]
@Gardening  - mention the Gardening forum
[/code]

[code]
@Gardening+ - mention the Gardening Forum and also post to the Gardening "network" (e.g. all the forum members; if you have permission to do so)
[/code]



[b]Private Mentions[/b]

If you wish to restrict a post to a single person or a number of people, you can do this by selecting channels or collections from the privacy tool. You can also just tag them with a privacy tag. A privacy tag is a name preceded by the two characters @! - and in addition to tagging these channels, will also change the privacy permissions of the post to only include them. You can have more than one privacy tag, for instance @!bob and @!linda will send the post only to Bob and Linda. This mechanism over-rides the privacy selector.  

You may also tag public collections. When you create or edit a collection, there is a checkbox to allow the group members to be seen by others. If this box is checked for a collection and you tag (for instance) @!Friends - the post will be restricted to the Friends collection. Check that the collection is public before doing this - as there is no way to take back a post except to delete it. The collection name will appear in the post and will alert members of that collection that they are members of it.    


[b]Mentions and Comments[/b]

The above mechanisms only apply to "top-level" posts you create. Mentioning a channel with any of the above mechanisms has no effect in comments, except that the mentioned channel may receive a notification if they were already included as a recipient in the conversation. 




[b]Topical Tags[/b]

Topical tags are indicated by preceding the tag name with the  # character. This will create a link in the post to a generalised site search for the term provided.  For example, #[zrl=https://friendicared.net/search?tag=cars]cars[/zrl] will provide a search link for all posts mentioning 'cars' on your site. Topical tags are generally a minimum of three characters in length.  Shorter search terms are not likely to yield any search results, although this depends on the database configuration. 

Topical tags are also not linked if they are purely numeric, e.g. #1. If you wish to use a numeric hashtag, please add some descriptive text such as #[zrl=https://friendicared.net/search?tag=2012-elections]2012-elections[/zrl].


[b]Spaces in Tags and Mentions[/b]

Where possible please use the auto-complete window to select tag and mention recipients, because it will generate a coded tag which uniquely identifies one channel. Names are sometimes ambiguous. However, you can "manually" tag a channel by matching the channel name or address.

[code]
@Robert Johnson
[/code]

will tag Robert Johnson, but we can only match one space. If the name was "Blind Lemon Jefferson" it won't be found unless you enclose the entire name in double quotes or change the spaces to underscores. 

[code]
@"Blind Lemon Jefferson"
@Blind_Lemon_Jefferson
[/code]

are both equivalent.  

Return to the [url=[baseurl]/help/main]Main documentation page[/url]
